VERSION 5.00
Begin VB.Form frmMain 
   ClientHeight    =   4290
   ClientLeft      =   165
   ClientTop       =   450
   ClientWidth     =   6270
   LinkTopic       =   "Form1"
   ScaleHeight     =   4290
   ScaleWidth      =   6270
   StartUpPosition =   1  'CenterOwner
   Begin VB.Data datLabels 
      Caption         =   "Data1"
      Connect         =   "Access"
      DatabaseName    =   "ABC.mdb"
      DefaultCursorType=   0  'DefaultCursor
      DefaultType     =   2  'UseODBC
      Exclusive       =   0   'False
      Height          =   375
      Left            =   5040
      Options         =   0
      ReadOnly        =   0   'False
      RecordsetType   =   1  'Dynaset
      RecordSource    =   "Labels"
      Top             =   360
      Visible         =   0   'False
      Width           =   1140
   End
   Begin VB.CommandButton cmdOutput 
      Caption         =   "Create Output File"
      Height          =   375
      Left            =   4440
      TabIndex        =   6
      Top             =   3720
      Width           =   1575
   End
   Begin VB.CommandButton cmdRules 
      Caption         =   "Process Rules"
      Height          =   375
      Left            =   2280
      TabIndex        =   5
      Top             =   3720
      Width           =   1575
   End
   Begin VB.CommandButton cmdProcessFiles 
      Caption         =   "Process File"
      Height          =   375
      Left            =   240
      TabIndex        =   4
      Top             =   3720
      Width           =   1575
   End
   Begin VB.Frame Frame1 
      Height          =   2655
      Left            =   1200
      TabIndex        =   0
      Top             =   240
      Width           =   3735
      Begin VB.CheckBox chkFileName 
         Height          =   735
         Index           =   2
         Left            =   240
         TabIndex        =   3
         Top             =   1680
         Width           =   3375
      End
      Begin VB.CheckBox chkFileName 
         Height          =   735
         Index           =   1
         Left            =   240
         TabIndex        =   2
         Top             =   960
         Width           =   3255
      End
      Begin VB.CheckBox chkFileName 
         Height          =   735
         Index           =   0
         Left            =   240
         TabIndex        =   1
         Top             =   240
         Width           =   3375
      End
   End
   Begin VB.Label lblStatus 
      Caption         =   "Label1"
      Height          =   375
      Left            =   960
      TabIndex        =   7
      Top             =   3120
      Width           =   3975
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuLabel 
      Caption         =   "&Label"
      Begin VB.Menu mnuLViewLabels 
         Caption         =   "&View Labels"
      End
   End
   Begin VB.Menu mnuPreferences 
      Caption         =   "&Preferences"
      Begin VB.Menu mnuPFileLocations 
         Caption         =   "File Lo&cations"
      End
      Begin VB.Menu mnuPMessagesOn 
         Caption         =   "&Messages On"
      End
      Begin VB.Menu mnuPMessagesOff 
         Caption         =   "Messages &Off"
      End
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private mdbDatabase As String
Private mbRulesEnabled As Boolean
Private mbMessagesOn As Boolean

Private Sub cmdOutput_Click()

    Call WriteOutput

End Sub

Private Sub cmdProcessFiles_Click()
    
    Dim intIndex As Integer
    Dim bOK As Boolean
    Dim vbmRetval As VbMsgBoxResult

    'Checks to see if a file type has been selected
    For intIndex = 0 To 2
    If chkFileName(intIndex).Value = 1 Then
        bOK = True
    End If
    Next

    'If no file type has been chosen show a message box
    If Not bOK Then
        MsgBox "You haven't selected any files for input"
        Exit Sub
    End If

    'Prompt to delete current recordset
    vbmRetval = MsgBox("Erase current label database?", vbYesNo)

    'Set mouse pointer and buttons
    Screen.MousePointer = vbHourglass
    cmdProcessFiles.Enabled = False
    cmdRules.Enabled = False
    cmdOutput.Enabled = False

    'If users clicks the Yes button call this routine
    If vbmRetval = vbYes Then
        Call EmptyLabels
    End If

    'If the Intermediate file already exists delete it
    If Len(Dir$(App.Path & "\INTERMEDIATE.TXT")) > 0 Then
        Kill App.Path & "\Intermediate.txt"
    End If

    'For each check box selected pass its caption to the ProcesFile routine
    For intIndex = 0 To 2
        If chkFileName(intIndex) = 1 Then
            ProcessFile (chkFileName(intIndex).Caption)
        End If
    Next

    'If Messages On is checked then show message box
    If mbMessagesOn Then
        MsgBox "Loading Access Table now..."
    End If

    'Now write data in Intermediate file to databse
    Call LoadAccessDatabase

    'Clear the check boxes
    For intIndex = 0 To 2
        chkFileName(intIndex).Value = 0
    Next

    'Reset the mouse and buttons
    Screen.MousePointer = vbDefault
    cmdProcessFiles.Enabled = True
    cmdOutput.Enabled = True
    cmdRules.Enabled = True

    'Enable Process Rules button
    mbRulesEnabled = True

    'Show message box if Messages On is checked
    If mbMessagesOn Then
        MsgBox "Label Processing completed"
    End If

End Sub

Private Sub cmdRules_Click()

    Dim vbmRetval As VbMsgBoxResult

    'Prompt to process rules
    vbmRetval = MsgBox("Are you sure you want to process rules?", vbOKCancel)

    'If no quit the routine
    If vbmRetval = vbCancel Then
        Exit Sub
    End If

    'Set the pointer and buttons
    Screen.MousePointer = vbHourglass
    cmdRules.Enabled = False
    cmdProcessFiles.Enabled = False
    cmdOutput.Enabled = False

    'Run the 5 rules in turn
    Call Rule1
    Call Rule2
    Call Rule3
    Call Rule4

    'Reset pointer and buttons
    Screen.MousePointer = vbDefault
    cmdRules.Enabled = False
    cmdProcessFiles.Enabled = True
    cmdOutput.Enabled = True

    'Change variable to False
    mbRulesEnabled = False

    MsgBox "Rule processing completed!"

End Sub

Private Sub Form_Load()

    'Set ABC.mdb in the path directory to be used
    mdbDatabase = App.Path & "\ABC.mdb"

    'Load the global variable default values
    Call SetDefaults

    'Set the form's caption
    frmMain.Caption = "ABC LTD. " & App.Major & "." & App.Minor & "." & App.Revision

    'Retrieve the value of MessagesOn from Registry
    mbMessagesOn = GetSetting("ABC", "StartUp", "mbMessagesOn", True)
    
    'Check the menu items
    If mbMessagesOn Then
        mnuPMessagesOn.Checked = True
    Else
        mnuPMessagesOff.Checked = True
    End If

    'Load the captions for the checkbox control array
    chkFileName(0).Caption = "PWW [" & gstrPWWLocation & "]"
    chkFileName(1).Caption = "AWW [" & gstrAWWLocation & "]"
    chkFileName(2).Caption = "WOOD [" & gstrWoodLocation & "]"

    mbRulesEnabled = False
    
    'Set the enabled property of the button
    cmdRules.Enabled = mbRulesEnabled

End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    
    Dim vbmResult As VbMsgBoxResult
    
    If UnloadMode = vbFormControlMenu Then
        'Cancel unload
        Cancel = True
        vbmResult = MsgBox("Are you sure you want to exit?", vbYesNo + vbQuestion)
    
        'If Yes then quit program
        If vbmResult = vbYes Then
            End
        End If
    End If

End Sub

Private Sub mnuFExit_Click()
    
    Dim vbmResult As VbMsgBoxResult
    
    'Prompt for confirmation of exit
    vbmResult = MsgBox("Are you sure you want to exit?", vbYesNo + vbQuestion)
    
    'If Yes then quit program
    If vbmResult = vbYes Then
        End
    End If
    
End Sub

Private Sub mnuLViewLabels_Click()

    'Hide the main form
    frmMain.Hide
    
    'Pass the database name to the data control on frmLabels
    frmLabels.datLabels.DatabaseName = mdbDatabase
    
    'Show the Labels form
    frmLabels.Show

End Sub

Private Sub mnuPFileLocations_Click()

    'Show the Files form
    frmFiles.Show
    
End Sub

Private Sub mnuPMessagesOff_Click()

    'Set variable and check menu items
    mbMessagesOn = False
    mnuPMessagesOn.Checked = False
    mnuPMessagesOff.Checked = True
    'Save new value to registry
    SaveSetting "ABC", "StartUp", "mbMessagesOn", False

End Sub

Private Sub mnuPMessagesOn_Click()

    'Set variable and check menu items
    mbMessagesOn = True
    mnuPMessagesOn.Checked = True
    mnuPMessagesOff.Checked = False
     'Save new value to registry
    SaveSetting "ABC", "StartUp", "mbMessagesOn", True

End Sub

Sub EmptyLabels()

    'Reset data control
    datLabels.Refresh

    'Delete entries in datacontrol reecordset
    Do While Not datLabels.Recordset.EOF
        datLabels.Recordset.Delete
        datLabels.Recordset.MoveNext
    Loop

    'Show message box
    If mbMessagesOn Then
        MsgBox "Labels now empty"
    End If

End Sub

Sub ProcessFile(strFileName As String)

    On Error GoTo ErrorHandler

    Dim strErrorFile As String

    'Show label of what's happening
    lblStatus.Visible = True
    lblStatus.Caption = "Processing " & strFileName & " now..."

    'Use 1st 3 letters of check box caption as the case
    Select Case Left$(UCase(strFileName), 3)

    Case "PWW"
        strErrorFile = gstrPWWLocation
        'Open file
        Open gstrPWWLocation For Input As #1
        'Open and create Intermediate file
        Open App.Path & "\INTERMEDIATE.TXT" For Append As #2
        'Run conversion routine
        Call ConvertPWW
    
    Case "AWW"
        strErrorFile = gstrAWWLocation
        'Open file
        Open gstrAWWLocation For Input As #1
        'Open and create Intermediate file
        Open App.Path & "\INTERMEDIATE.TXT" For Append As #2
        'Run conversion routine
        Call ConvertAWW
    
    Case "WOO"
        strErrorFile = gstrWoodLocation
        'Open file
        Open gstrWoodLocation For Input As #1
        'Open and create Intermediate file
        Open App.Path & "\INTERMEDIATE.TXT" For Append As #2
        'Run conversion routine
        Call ConvertWood

    Case Else
        'For any other option show message box error and quit routine
        MsgBox "System Error!", vbExclamation
        Exit Sub
    
    End Select

    'Close any open files
    Close

    'Hide label
    lblStatus.Visible = False

    Exit Sub

'Error routine
ErrorHandler:
    Select Case Err.Number
  
    Case 53
       MsgBox strErrorFile & "Does not exist.  Please check your file names and restart"
       'Close any open files
       Close
       Exit Sub
  
    Case Else
        'Run error box routine
        Call RaiseError
        'Close any open file
        Close
        Exit Sub

    End Select

End Sub

Sub ConvertAWW() 'Conceversion routine for AWW files

    On Error GoTo ErrorHandler

    Dim strFiller As String
    Dim strFirst_Name As String
    Dim strLast_Name As String
    Dim strAddress1 As String
    Dim strAddress2 As String
    Dim strCity As String
    Dim strState As String
    Dim strZip As String
    Dim strSource As String

    strSource = "AWW"

    'Store AWW file data in variables
    Do While Not EOF(1)
        Input #1, strFiller, strFiller, strFiller, strFirst_Name, _
            strLast_Name, strFiller, strFiller, _
            strAddress1, strAddress2, strCity, strState, strZip, _
            strFiller, strFiller
    
        'Write variables to Intermediate file
        Write #2, UCase(strFirst_Name), _
                  UCase(strLast_Name), _
                  UCase(strAddress1), _
                  UCase(strAddress2), _
                  UCase(strCity), _
                  UCase(strState), _
                  UCase(strZip), _
                  strSource
        'Allow anyother processes to occur before looping
        DoEvents
    Loop
    
    Exit Sub

ErrorHandler:
    Select Case Err.Number
    
    Case 62 'Input past end of file
        Close
        Exit Sub
  
    Case Else
        Call RaiseError
        Close
        Exit Sub
    
    End Select

End Sub

Sub ConvertPWW() 'Conversion routine for PWW files

    Dim strFirst_Name As String
    Dim strLast_Name As String
    Dim strAddress1 As String
    Dim strAddress2 As String
    Dim strCity As String
    Dim strState As String
    Dim strZip As String
    Dim strFiller As String
    Dim strSource As String

    strSource = "PWW"

    'Store data from PWW file in variables
    Do While Not EOF(1)
        Input #1, strLast_Name, _
                  strAddress1, _
                  strAddress2, _
                  strCity, _
                  strState, _
                  strZip
        strFirst_Name = "DUMMY FIRST NAME"
    
    'Write variables to Intermediate file
    Write #2, UCase(strFirst_Name), _
              UCase(strLast_Name), _
              UCase(strAddress1), _
              UCase(strAddress2), _
              UCase(strCity), _
              UCase(strState), _
              UCase(strZip), _
              strSource
    
        'Allow other processes to occur before looping
        DoEvents
    
    Loop

    Exit Sub

ErrorHandler:
    Select Case Err.Number
    Case 62 'Input past End of File
        Close
        Exit Sub
  
    Case Else
        Call RaiseError
        Close
        Exit Sub

    End Select

End Sub

Sub ConvertWood() 'Conversion routine for WOOD files

    On Error GoTo ErrorHandler

    Dim strFiller As String
    Dim strFirst_Name As String
    Dim strLast_Name As String
    Dim strAddress1 As String
    Dim strAddress2 As String
    Dim strAddress3 As String
    Dim strCity As String
    Dim strState As String
    Dim strZip1 As String
    Dim strZip2 As String
    Dim strZip As String
    Dim strSource As String

    strSource = "WOOD"

    'Store WOOD file data in variables
    Do While Not EOF(1)
        Input #1, strFiller, strFirst_Name, strLast_Name, strFiller, _
                  strFiller, strAddress1, strAddress2, strAddress3, _
                  strFiller, strFiller, strCity, strState, strFiller, _
                  strFiller, strZip1, strZip2
    
        'Concatenate several variables into one
        strAddress2 = strAddress2 & ", " & strAddress3
        strZip = strZip1 & " " & strZip2
           
        'Write variables to Intermediate file
        Write #2, UCase(strFirst_Name), _
                  UCase(strLast_Name), _
                  UCase(strAddress1), _
                  UCase(strAddress2), _
                  UCase(strCity), _
                  UCase(strState), _
                  UCase(strZip), _
                  strSource
        
        'Allow other processes to occur
        DoEvents

    Loop

    Exit Sub

ErrorHandler:
    Select Case Err.Number
        Case 62 'Input past End of File
            Close
            Exit Sub
        
        Case Else
            Call RaiseError
            Close
            Exit Sub
        
        End Select

End Sub

Sub LoadAccessDatabase() 'Loads database with Intermediate File data

    On Error GoTo ErrorHandler

    Dim intCounter As Integer
    Dim strFirst_Name As String
    Dim strLast_Name As String
    Dim strAddress1 As String
    Dim strAddress2 As String
    Dim strCity As String
    Dim strState As String
    Dim strZip As String
    Dim strSource As String
    Dim dbMyDB As Database
    Dim recMyRs As Recordset

    'Open database and set recordset
    Set dbMyDB = Workspaces(0).OpenDatabase(mdbDatabase)
    Set recMyRs = dbMyDB.OpenRecordset("Labels", dbOpenTable)

    'Open Intermediate file
    Open App.Path & "\INTERMEDIATE.TXT" For Input As #1

    'Write Intermediate file data to variable
    Do While Not EOF(1)
        Input #1, strFirst_Name, _
                  strLast_Name, _
                  strAddress1, _
                  strAddress2, _
                  strCity, _
                  strState, _
                  strZip, _
                  strSource
        
        'Load database fields with variables
        recMyRs.AddNew
        recMyRs("Firstname") = Trim(strFirst_Name)
        recMyRs("Lastname") = Trim(strLast_Name)
        recMyRs("Address1") = Trim(strAddress1)
        recMyRs("Address2") = Trim(strAddress2)
        recMyRs("City") = Trim(strCity)
        recMyRs("State") = Trim(strState)
        recMyRs("Zip") = Trim(strZip)
        recMyRs("Source") = Trim(strSource)
        recMyRs("DateCreated") = Now
        recMyRs.Update
        'Increase counter by 1
        intCounter = intCounter + 1
    Loop

    'Close database
    recMyRs.Close
    dbMyDB.Close

    'Clean up
    Set recMyRs = Nothing
    Set dbMyDB = Nothing

    'Close file
    Close #1

    'Show number of records processed in a message box
    MsgBox intCounter & " records processed"

Exit Sub

ErrorHandler:
    Select Case Err.Number
        Case 62 'Input past End of File
            Close
            MsgBox intCounter & " records processed"
            Close
            Exit Sub
    
        Case 3022    'Duplicate record check
            intCounter = intCounter - 1
            Resume Next
        
        Case Else
            Call RaiseError
            Close
            Exit Sub
    
    End Select

End Sub

Sub Rule1() 'Splits Name into First and Last of PWW files

    On Error GoTo ErrorHandler

    Dim intCounter As Integer
    Dim dbMyDB As Database
    Dim recMyRs As Recordset

    'Open database and table
    Set dbMyDB = Workspaces(0).OpenDatabase(mdbDatabase)
    Set recMyRs = dbMyDB.OpenRecordset("Labels", dbOpenTable)

    'Check that this isn't a Rule 3
    If recMyRs("LastName") <> "" Then
        Do While Not recMyRs.EOF
            'Split Name into First and Last by running routines
            If recMyRs("FirstName") = "DUMMY FIRST NAME" Then
                recMyRs.Edit
                recMyRs("Firstname") = GetFirstName(recMyRs("LastName"))
                recMyRs("Lastname") = GetLastName(recMyRs("LastName"))
                'Seet Rules Applied Field
                recMyRs("RulesApplied") = recMyRs("RulesApplied") & " Rule1"
                recMyRs.Update
                intCounter = intCounter + 1
            End If

        recMyRs.MoveNext
    Loop

    End If

    'Close database
    recMyRs.Close
    dbMyDB.Close

    'Clean up
    Set dbMyDB = Nothing
    Set recMyRs = Nothing

    'Show message if selected to
    If mbMessagesOn Then
        MsgBox intCounter & " Rule 1 records changed"
    End If

    Exit Sub

ErrorHandler:
    Call RaiseError
    Exit Sub

End Sub

Sub Rule2() 'Moves middle inital to FirstName field

    On Error GoTo ErrorHandler

    Dim intCounter As Integer
    Dim dbMyDB As Database
    Dim recMyRs As Recordset
    Dim strLastName As String
    Dim strFirstName As String

    'Open database and table
    Set dbMyDB = Workspaces(0).OpenDatabase(mdbDatabase)
    Set recMyRs = dbMyDB.OpenRecordset("Labels", dbOpenTable)

    Do While Not recMyRs.EOF

    strLastName = recMyRs("Lastname")
    strFirstName = recMyRs("Firstname")

    If Len(strLastName) > 2 Then
        'Test for a space or full stop
        If Mid$(strLastName, 2, 1) = " " Or Mid$(strLastName, 2, 1) = "." Then
            recMyRs.Edit
            'Move intial to FirstName fiels
            recMyRs("Firstname") = strFirstName & " " & Left$(strLastName, 1)
            'Remove  intial from LastName field
            recMyRs("Lastname") = Right$(strLastName, Len(strLastName) - 2)
            'Set RulesApplied Field
            recMyRs("RulesApplied") = recMyRs("RulesApplied") & " Rule2"
            recMyRs.Update
            intCounter = intCounter + 1
        End If
    End If

    recMyRs.MoveNext
    Loop

    'Close database
    recMyRs.Close
    dbMyDB.Close

    'Clean up
    Set dbMyDB = Nothing
    Set recMyRs = Nothing

    'Show message if selected to
    If mbMessagesOn Then
        MsgBox intCounter & " Rule 2 records changed"
    End If

    Exit Sub

ErrorHandler:
    Call RaiseError
    Exit Sub

End Sub

Sub Rule3() 'If no name set to Resident WoodWorker

    On Error GoTo ErrorHandler

    Dim intCounter As Integer
    Dim dbMyDB As Database
    Dim recMyRs As Recordset

    'Open database and table
    Set dbMyDB = Workspaces(0).OpenDatabase(mdbDatabase)
    Set recMyRs = dbMyDB.OpenRecordset("Labels", dbOpenTable)

    Do While Not recMyRs.EOF

    If recMyRs("Lastname") = "" Then
           recMyRs.Edit
           'Set LastName field
           recMyRs("LastName") = "RESIDENT WOODWORKER"
           'Clear FirstName field in case it said DummyName
           recMyRs("FirstName") = ""
           'Set RulesApplied Field
           recMyRs("RulesApplied") = recMyRs("RulesApplied") & " Rule3"
           recMyRs.Update
           intCounter = intCounter + 1
    End If

    recMyRs.MoveNext
    Loop

    'Close the database
    recMyRs.Close
    dbMyDB.Close

    'Clean up
    Set dbMyDB = Nothing
    Set recMyRs = Nothing

    'Show message if selected to
    If mbMessagesOn Then
        MsgBox intCounter & " Rule 3 records changed"
    End If

    Exit Sub

ErrorHandler:
    Call RaiseError
    Exit Sub

End Sub

Sub Rule4() 'Move Address2 to Address1

    On Error GoTo ErrorHandler

    Dim intCounter As Integer
    Dim dbMyDB As Database
    Dim recMyRs As Recordset

    'Open database and table
    Set dbMyDB = Workspaces(0).OpenDatabase(mdbDatabase)
    Set recMyRs = dbMyDB.OpenRecordset("Labels", dbOpenTable)

    Do While Not recMyRs.EOF

    If (recMyRs("Address1")) = "" Then
        recMyRs.Edit
        'Set Address1 to Address2 Field
        recMyRs("Address1") = recMyRs("Address2")
        'Clear Address2
        recMyRs("Address2") = ""
        'Set RulesApplied Field
        recMyRs("RulesApplied") = recMyRs("RulesApplied") & " Rule4"
        recMyRs.Update
        intCounter = intCounter + 1
    End If

    recMyRs.MoveNext
    Loop

    'Close the database
    recMyRs.Close
    dbMyDB.Close

    'Clean up
    Set dbMyDB = Nothing
    Set recMyRs = Nothing


    'Show message if selected to do so
    If mbMessagesOn Then
        MsgBox intCounter & " Rule 4 records changed"
    End If

    Exit Sub

ErrorHandler:
    Call RaiseError
    Exit Sub

End Sub

Sub WriteOutput() 'Creates Output file

    On Error GoTo ErrorHandler

    Dim intCounter As Integer
    Dim strFirst_Name As String
    Dim strLast_Name As String
    Dim strAddress1 As String
    Dim strAddress2 As String
    Dim strCity As String
    Dim strState As String
    Dim strZip As String
    Dim strSource As String
    Dim dtmFileDate As Date
    Dim strFileType As String
    Dim dbMyDB As Database
    Dim recMyRs As Recordset

    'Open database and table
    Set dbMyDB = Workspaces(0).OpenDatabase(mdbDatabase)
    Set recMyRs = dbMyDB.OpenRecordset("Labels", dbOpenTable)

    'Create and open file
    Open gstrOutputLocation For Output As #1

    'Set variables from database
    Do While Not recMyRs.EOF
        strFirst_Name = recMyRs("Firstname").Value
        strLast_Name = recMyRs("Lastname").Value
        strAddress1 = recMyRs("Address1").Value
        strAddress2 = recMyRs("Address2").Value
        strCity = recMyRs("City").Value
        strState = recMyRs("State").Value
        strZip = recMyRs("Zip").Value
        strSource = recMyRs("Source").Value
        dtmFileDate = Format(Now, "YYMMDD")
        strFileType = "K"

    'Write variables to file
    Write #1, UCase(strLast_Name), _
              UCase(strFirst_Name), _
              UCase(strAddress1), _
              UCase(strAddress2), _
              UCase(strCity), _
              UCase(strState), _
              UCase(strZip), _
              UCase(strSource), _
              dtmFileDate, _
              strFileType
    intCounter = intCounter + 1
    recMyRs.MoveNext
    Loop

    MsgBox "Output labels generated to " & gstrOutputLocation

    'Close database
    recMyRs.Close
    dbMyDB.Close

    'Clean up
    Set dbMyDB = Nothing
    Set recMyRs = Nothing

    'Close the file
    Close #1

    Exit Sub

ErrorHandler:
    Call RaiseError
    Exit Sub

End Sub

Function GetFirstName(strFullName As String) As String

    Dim intNameLength As Integer
    Dim intFindSpace As Integer

    intNameLength = Len(strFullName)
    intFindSpace = InStr(strFullName, " ")
    
    'Take characters to the left of the space
    GetFirstName = Left$(strFullName, intFindSpace - 1)

End Function

Function GetLastName(strFullName As String) As String

    Dim intNameLength As Integer
    Dim intFindSpace As Integer

    'Look for space in Name
    intNameLength = Len(strFullName)
    intFindSpace = InStr(strFullName, " ")
    
    'Take characters to the right of the space
    GetLastName = Right$(strFullName, intNameLength - intFindSpace)
    
End Function

Sub RaiseError() 'Shows a message box with error number and description

    MsgBox "Unanticipated error! " & vbCrLf & Err.Number & ": " & Err.Description, vbExclamation

End Sub
