VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "DerivedClass"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
' The derived class inherits the interface from the base class
' Note that we inherit the interface of a full-fledged class, not
' just some aspect of the interface.
Implements BaseClass

' We use a private member of the base class to be able to reuse
' the implementation of the base class.
Private m_objBaseClass As BaseClass

' -------- THE DERIVED CLASS OWNS A PRIVATE INSTANCE OF THE BASE CLASS --------
Private Sub Class_Initialize()
' Typically the base class is owned by the derived class,
' though containment is also possible.
   Set m_objBaseClass = New BaseClass
End Sub

Private Sub Class_Terminate()
   Set m_objBaseClass = Nothing
End Sub

' -------- PUBLIC METHODS AND PROPERTIES OF THE DERIVED CLASS --------
Public Sub Init(ByVal FirstName As String, ByVal LastName As String)
   BaseClass_Init FirstName, LastName
End Sub

Public Sub ShowNames()
   BaseClass_ShowNames
' Here you may add code specific to the derived class
End Sub

Public Function SimpleFunction() As String
' In this example we extend the SimpleFunction in the derived class
   SimpleFunction = "Miss " & BaseClass_SimpleFunction
End Function

' -------- ENSURE THE DERIVED CLASS INHERITS FROM THE BASE CLASS --------
' The private methods and properties of the interface are implemented
' using the private base class.
Private Sub BaseClass_Init(ByVal FirstName As String, ByVal LastName As String)
   m_objBaseClass.Init FirstName, LastName
End Sub

Private Sub BaseClass_ShowNames()
   m_objBaseClass.ShowNames
End Sub

Private Function BaseClass_SimpleFunction() As String
   BaseClass_SimpleFunction = m_objBaseClass.SimpleFunction
End Function

