VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 1  'NoTransaction
END
Attribute VB_Name = "Payees"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

' Class module in business tier

' In this module we are only concerned with success/failure
Public Enum EUpdateStatus
  UPDSUCCESS = 0
  UPDERROR = 1
End Enum

Const MODULE_NAME As String = "Bank_Bus.Payees"

Public Property Get MatchPayee(ByVal BankID As Integer, _
  ByVal CardID As Long) As Boolean
' Check for matching payees in the Payee table

  Dim objBank As Bank_DB.Payees
  
  On Error GoTo ErrorHandler

  Set objBank = CtxCreateObject("Bank_DB.Payees")
  
  'Passthrough call to data tier
  MatchPayee = objBank.MatchPayee(BankID, CardID)
  
  CtxSetComplete
  
Clean_Up:
  Set objBank = Nothing
  Exit Property

ErrorHandler:
  RaiseError MODULE_NAME, "MatchPayee(" & CStr(BankID) & ", " _
    & CStr(CardID) & ")"
  GoTo Clean_Up
End Property

Public Property Get InsertPayees(ByVal PayeeDescription As String, _
  ByVal AccountID As Long, ByVal DefaultAmount As Currency, _
  ByVal BankID As Integer, ByVal CardID As Long, _
  ByVal WROBACardID As Long) As EUpdateStatus
' Add a new payee

  Dim objBank As Bank_DB.Payees
  
  On Error GoTo ErrorHandler

  InsertPayees = EUpdateStatus.UPDERROR
  Set objBank = CtxCreateObject("Bank_DB.Payees")
  
  'Passthrough call to data tier
  InsertPayees = objBank.InsertPayees(PayeeDescription, _
    AccountID, DefaultAmount, BankID, CardID, WROBACardID)
  
  CtxSetComplete

Clean_Up:
  Set objBank = Nothing
  Exit Property

ErrorHandler:
  RaiseError MODULE_NAME, "InsertPayees(" & CStr(BankID) & ", " _
    & CStr(CardID) & ")"
  GoTo Clean_Up
End Property

Public Property Get EditPayee(ByVal PayeeID As String, _
  ByVal PayeeDescription As String, ByVal DefaultAmount As Currency, _
  ByVal BankID As Integer) As EUpdateStatus

  Dim objBank As Bank_DB.Payees
  
  On Error GoTo ErrorHandler

  EditPayee = EUpdateStatus.UPDERROR
  Set objBank = CtxCreateObject("Bank_DB.Payees")
  
  'Passthrough call to data tier
  EditPayee = objBank.EditPayee(PayeeID, PayeeDescription, _
    DefaultAmount, BankID)
  
  CtxSetComplete

Clean_Up:
  Set objBank = Nothing
  Exit Property

ErrorHandler:
  RaiseError MODULE_NAME, "EditPayee(" & CStr(BankID) & ", " _
    & PayeeDescription & ")"
  GoTo Clean_Up
End Property

  Public Property Get DeletePayee(ByVal PayeeID As String, _
  ByVal BankID As Integer, ByVal PayeeDescription As String) _
  As EUpdateStatus

  Dim objBank As Bank_DB.Payees
  Dim strDSN As String
  
  On Error GoTo ErrorHandler

  DeletePayee = EUpdateStatus.UPDERROR
  Set objBank = CtxCreateObject("Bank_DB.Payees")
  
  'Passthrough call to data tier
  DeletePayee = objBank.DeletePayee(PayeeID, BankID, _
    PayeeDescription)
  
  CtxSetComplete
  
Clean_Up:
  Set objBank = Nothing
  Exit Property

ErrorHandler:
  RaiseError MODULE_NAME, "DeletePayee(" & CStr(BankID) & ", " _
    & PayeeDescription & ")"
  GoTo Clean_Up
End Property
   
Public Property Get GetAllPayees(ByVal BankID As Integer, _
  ByVal CardID As Long) As ADODB.Recordset
'Get all payees for this bank

  Dim objBank As Bank_DB.Payees
  
  On Error GoTo ErrorHandler

  Set objBank = CtxCreateObject("Bank_DB.Payees")
  
  'Passthrough call to data tier
  Set GetAllPayees = objBank.GetAllPayees(BankID, CardID)
  
  CtxSetComplete

Clean_Up:
  Set objBank = Nothing
  Exit Property

ErrorHandler:
  RaiseError MODULE_NAME, "GetAllPayees(" & CStr(BankID) & ")"
  GoTo Clean_Up
End Property

