VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Accounts"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Public Function AccountBalances(ByVal BankID As Long, _
                ByVal ClientID As Long) As ADODB.Recordset
   Dim oBank As Bank_XML.Accounts
   Dim oDOM As MSXML.DOMDocument
   Dim oNode As MSXML.IXMLDOMElement
   Dim colNodes As MSXML.IXMLDOMNodeList
   Dim oRS As ADODB.Recordset
   Dim sResponse As String
   
   On Error GoTo ERR_AccountBalances
   
   'build the request
   Set oDOM = New MSXML.DOMDocument
   Set oNode = AddElement(oDOM, "request")
   Call AddAttribute("type", "GetAccounts", oNode)
   Call AddElement(oDOM, "bankid", BankID, oNode)
   Call AddElement(oDOM, "clientid", ClientID, oNode)
   
   'send the request to the Bank
   Set oBank = New Bank_XML.Accounts
   sResponse = oBank.GetAccounts(oDOM.xml)
   
   'convert the response to a recordset (for example only, _
          not really required)
   If Len(sResponse) > 0 Then
      Set oDOM = New MSXML.DOMDocument
      Call oDOM.loadXML(sResponse)
      
      Set oRS = New ADODB.Recordset
      'add the fields of interest to the new recordset
      Call BuildRecordset(oRS)
      
      Call oRS.Open
      'add the records defined in the <accounts> section
      Set colNodes = oDOM.getElementsByTagName("account")
      Call AddRecords(oRS, colNodes)
   End If
   
EXIT_AccountBalances:
   'return the new recordset
   Set AccountBalances = oRS
Exit Function

ERR_AccountBalances:
   Select Case Err.Number
      Case Else
         MsgBox "Error retrieving account balances." & vbCrLf & Err.Description, _
                                          vbExclamation, "Error: " & Err.Number
         Resume EXIT_AccountBalances
   End Select
   
   Resume 0
End Function

Private Sub BuildRecordset(ByRef Data As ADODB.Recordset)
   'adds the appropriate fields to an closed, but created recordset
   
   'the only fields we really want are:
   '   AccountTypeDesc
   '   Balance="234"
   With Data.Fields
      Call .Append("AccountID", adInteger)
      Call .Append("Account", adVarChar, 15)
      Call .Append("Balance", adCurrency)
   End With
   
End Sub

Private Sub AddRecords(ByRef Data As ADODB.Recordset, _
          ByVal Records As MSXML.IXMLDOMNodeList)
   Dim oNode As MSXML.IXMLDOMElement
   Dim iCount As Integer
   Dim lID As Long
   Dim sAccount As String
   Dim cBalance As Currency
   
   'adds a number of XML nodes to a recordset
   
   For iCount = 0 To Records.length - 1
      Set oNode = Records.Item(iCount)
      With oNode
         lID = CLng(.getAttribute("AccountId"))
         sAccount = Trim$(.getAttribute("AccountTypeDesc"))
         cBalance = .getAttribute("Balance")
      End With

      Call Data.AddNew(Array("AccountID", "Account", "Balance"), _
                Array(lID, sAccount, cBalance))
   Next
   
End Sub

Public Function TransferFunds(ByVal FromBankID As Long, _
                 ByVal FromAccountID As Long, _
                 ByVal ToBankID As Long, ByVal ToAccountID As Long, _
                 ByVal Quantity As Currency) As String
   
   Dim oDOM As MSXML.DOMDocument
   Dim oRoot As MSXML.IXMLDOMElement
   Dim oChild As MSXML.IXMLDOMElement
   Dim oBank As Bank_XML.Accounts
   Dim sResult As String
   
   'Calls Bank_Bus (via XML) to transfer funds, _
        returns a string representing the result
   
   On Error GoTo ERR_TransferFunds
   
   'build the request
   Set oDOM = New MSXML.DOMDocument
   Set oRoot = AddElement(oDOM, "request")
   Call AddAttribute("type", "TransferFunds", oRoot)
   
   'add the 'from' account information
   Set oChild = AddElement(oDOM, "from", , oRoot)
   Call AddElement(oDOM, "bank", FromBankID, oChild)
   Call AddElement(oDOM, "account", FromAccountID, oChild)
   
   'add the 'to' account information
   Set oChild = AddElement(oDOM, "to", , oRoot)
   Call AddElement(oDOM, "bank", ToBankID, oChild)
   Call AddElement(oDOM, "account", ToAccountID, oChild)
   
   'add the quantity
   Call AddElement(oDOM, "quantity", Quantity, oRoot)
   
   'send the request to the bank
   Set oBank = New Bank_XML.Accounts
   
   'retrieve the result
   sResult = oBank.TransferFunds(oDOM.xml)
   
EXIT_TransferFunds:
   TransferFunds = sResult
Exit Function

ERR_TransferFunds:
   Select Case Err.Number
      Case Else
         MsgBox "Error retrieving account balances." _
               & vbCrLf & Err.Description, _
               vbExclamation, "Error: " & Err.Number
         Resume EXIT_TransferFunds
   End Select
   
   Resume 0
End Function


