VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsDBSupplier"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private m_DB As Database


Private Sub Class_Initialize()

    ' Set up a connection to the Northwind database
    Set m_DB = Workspaces(0).OpenDatabase(App.Path & "\nwind.mdb")

End Sub

Private Sub Class_Terminate()

    ' Close the connection to the database
    m_DB.Close
    Set m_DB = Nothing

End Sub





Public Function Find_Supplier(ByVal lngID As Long, _
    supBusinessObject As clsSupplier) As Boolean
' Find a supplier record, and copy the data to the
' supBusinessObject passed in
  
  Dim recSuppliers As Recordset
    
    Set recSuppliers = m_DB.OpenRecordset _
("SELECT * FROM Suppliers WHERE SupplierID = " & lngID, dbOpenSnapshot)
    
    If recSuppliers.EOF Then
        Find_Supplier = False
        ' There was no supplier found matching the ID,
        ' so clear the data out
        With supBusinessObject
        
            .strCompanyName = ""
            .strContactName = ""
            .strContactTitle = ""
            .strAddress = ""
            .strCity = ""
            .strRegion = ""
            .strPostalCode = ""
            .strCountry = ""
            .strPhone = ""
            .strFax = ""
            
        End With
    Else
    
        ' A supplier was found,
        ' so set the fields in the supplier object up
        Find_Supplier = True
        
        With supBusinessObject
        
            .strCompanyName = "" & recSuppliers!CompanyName
            .strContactName = "" & recSuppliers!ContactName
            .strContactTitle = "" & recSuppliers!ContactTitle
            .strAddress = "" & recSuppliers!Address
            .strCity = "" & recSuppliers!City
            .strRegion = "" & recSuppliers!Region
            .strPostalCode = "" & recSuppliers!PostalCode
            .strCountry = "" & recSuppliers!Country
            .strPhone = "" & recSuppliers!Phone
            .strFax = "" & recSuppliers!Fax
            
        End With
        
    End If
    
    recSuppliers.Close
    

End Function

Public Function CreateNewSupplier(supNewSupplier As clsSupplier) As Long
' Copies the properties in the supNewSupplier object into
' the fields in the Suppliers table in the database.

    Dim recSuppliers As Recordset
    
    Set recSuppliers = m_DB.OpenRecordset("Suppliers", dbOpenTable)
    
    recSuppliers.AddNew
    SetRecordFields supNewSupplier, recSuppliers
    recSuppliers.Update

    recSuppliers.Bookmark = recSuppliers.LastModified
    CreateNewSupplier = recSuppliers!SupplierID

    recSuppliers.Close

End Function
Private Sub SetRecordFields(supTheSupplier As clsSupplier, recSupplierData As Recordset)
' Copies the contents of the supplier object's properties out to the
' current record's fields

    With supTheSupplier
    
        recSupplierData!CompanyName = .strCompanyName
        recSupplierData!ContactName = .strContactName
        recSupplierData!ContactTitle = .strContactTitle
        recSupplierData!Address = .strAddress
        recSupplierData!City = .strCity
        recSupplierData!Region = .strRegion
        recSupplierData!Country = .strCountry
        recSupplierData!PostalCode = .strPostalCode
        recSupplierData!Phone = .strPhone
        recSupplierData!Fax = .strFax

    End With

End Sub
Public Sub UpdateExistingSupplier(ByVal lngID As Long, supChangedData As clsSupplier)
' Locates the supplier record specified by lngID
' and then copies the properties from supChangedData into it.
    
    Dim recSuppliers As Recordset
    
    Set recSuppliers = m_DB.OpenRecordset("Suppliers", dbOpenTable)
    
    recSuppliers.Index = "PrimaryKey"
    recSuppliers.Seek "=", lngID
    
    If Not recSuppliers.NoMatch Then
    
        recSuppliers.Edit
        SetRecordFields supChangedData, recSuppliers
        recSuppliers.Update
    
    End If
    
    recSuppliers.Close

End Sub

Public Sub Get_Supplier_Names(lngIDNos() As Long, strNames() As String)
' Grab a list of supplier numbers and names and put them into
' the two variable length arrays that were passed in as parameters

    Dim recSuppliers As Recordset
    Dim intCounter As Integer
    
    ' First, clear out the arrays
    ReDim lngIDNos(0)
    ReDim strNames(0)
    
    ' Next, grab a list of the supplier names,
    ' with their ID's from the database
    Set recSuppliers = m_DB.OpenRecordset _
("SELECT SupplierID, CompanyName FROM Suppliers ORDER BY CompanyName", _
        dbOpenSnapshot)
        
    intCounter = 0
    ' Start a loop through the list of suppliers
    Do While Not recSuppliers.EOF

        intCounter = intCounter + 1
        
        ReDim Preserve lngIDNos(intCounter - 1)
        ReDim Preserve strNames(intCounter - 1)
        

        
        lngIDNos(intCounter - 1) = recSuppliers!SupplierID
        strNames(intCounter - 1) = recSuppliers!CompanyName
        
        recSuppliers.MoveNext
        

        
    Loop
    
    ' Close the connection to the recordset
    recSuppliers.Close
    
End Sub



