VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 4  'RequiresNewTransaction
END
Attribute VB_Name = "OrderProcessor"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' Create somewhere to put the ObjectContext object
' that MTS will give us...
Private m_objCtx As ObjectContext

' Tell MTS that we support the ObjectControl interface...
Implements ObjectControl

' MTS will call this when our object is instantiated...
Private Sub ObjectControl_Activate()
    Set m_objCtx = GetObjectContext
End Sub

' and MTS will call this when our object is deleted...
Private Sub ObjectControl_Deactivate()
    Set m_objCtx = Nothing
End Sub


' Process the order...
Public Function ProcessOrder(cart, address) As Boolean

    ' Somewhere to put an error result...
    Dim blnResult As Boolean
    blnResult = False
    
    ' Firstly, create a new customer...
    ' (we'll implement this function in the next section)
    blnResult = CreateCustomer(address)
    
    ' Only do the rest if that succeeded...
    If blnResult = True Then
        ' This is where we'll mess about with the
        ' products and create the actual order...
    End If
    
    ' Did we manage it?
    If blnResult = True Then
    
        ' Tell MTS we did it!
        m_objCtx.SetComplete
    
    Else
    
        ' Tell MTS it all went wrong!
        m_objCtx.SetAbort
    
    End If
    
    ' Return the result back to the caller...
    ProcessOrder = blnResult

End Function

' Inserts a new customer into the database based on the information
' contained in the "address" collection...
Private Function CreateCustomer(address)
    
    ' get a connection to the store...
    Dim store
    Set store = CreateObject("darrenstore.store")
    
    ' make a SQL string based on the address dictionary...
    Dim strSQL
    strSQL = "insert into customers (first, last, email) values ("
    strSQL = strSQL & "'" & address("FirstName") & "', "
    strSQL = strSQL & "'" & address("LastName") & "', "
    strSQL = strSQL & "'" & address("EMail") & "')"
    store.propConn.Execute strSQL
    
    ' cleanup
    Set store = Nothing
    
    ' tell it we succeeded...
    CreateCustomer = True

End Function


Private Function ReportError(message)

    ' Do we have the ASP Response intrinsic object?
    If TypeName(m_objCtx.Item("Response")) = "IResponse" Then
        m_objCtx.Item("Response").Write "<font color=#800e000f>"
        m_objCtx.Item("Response").Write message
        m_objCtx.Item("Response").Write "</font><br><br>"
    End If
    
'    ' Either way, send an e-mail to the sysadmin...
'    Dim email
'    Set email = CreateObject("SomeEMailComponent")
'    email.AddRecipient "sysadmin@darrenstore.com"
'    email.Send
'    Set email = Nothing

End Function

