VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "SalesOrderItem"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"37488AE50300"
Option Explicit

'##ModelId=374C45C50165
Private Const mcClassName As String = "UIObjects.SalesOrderItem"
'##ModelId=374C45C501FB
Private Const mcObjectError As String = vbObjectError + &H1130

'##ModelId=374C45C502A6
Private mQuantity As Integer
'##ModelId=37488E690337
Private mProduct As Product

'##ModelId=374C45C5035A
Public Property Let ProductID(ByVal Value As Long)
    mProduct.Read Value
End Property

'Retrieve the price of an item.  It is assumed that it must be the same as the
'price we set for a product and cannot be changed by the order entry program.
'It is implemented so that we can relax this restriction in the future.
'##ModelId=37488F27013A
Public Property Get Price() As Currency
    Let Price = Product.Price
End Property

'Assign the order quantity for an item.
'##ModelId=37488FC002D5
Public Property Let Quantity(ByVal Value As Integer)
    Let mQuantity = Value
End Property

'Retrieve quantity ordered for a product.
'##ModelId=3748901F024F
Public Property Get Quantity() As Integer
    Let Quantity = mQuantity
End Property

'##ModelId=374C45C601B7
Public Property Get Amount() As Currency
    Let Amount = Price * Quantity
End Property

'##ModelId=374AECB20014
Public Property Get Product() As Product
    Set Product = mProduct
End Property


'##ModelId=374AECB102CF
Public Property Set Product(ByVal Value As Product)
    Set mProduct = Value
End Property

'##ModelId=374A1C550306
Friend Function Serialize() As String
    On Error GoTo ErrHandler
    
    Dim PropBag As PropertyBag
    Set PropBag = New PropertyBag
    With PropBag
        .WriteProperty "ProductID", Product.ID
        .WriteProperty "Price", Price
        .WriteProperty "Quantity", Quantity
        Serialize = .Contents
    End With
    
FuncExit:
    On Error Resume Next
    If Not PropBag Is Nothing Then
        Set PropBag = Nothing
    End If
    
    Exit Function
    
ErrHandler:
    Err.Raise mcObjectError + 11, mcClassName, Err.Description
    Resume FuncExit
End Function


'##ModelId=374C45C70096
Private Sub Class_Initialize()
    Set mProduct = New Product
End Sub

'##ModelId=374C45C70118
Private Sub Class_Terminate()
    On Error Resume Next
    Set mProduct = Nothing
End Sub
