VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Process"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

'Declare ScriptingContext variables
Private m_Application As Application
Private m_Request As Request
Private m_Response As Response
Private m_Session As Session

'Declare Database variables
Private m_objConn As New ADODB.Connection
Private m_objRs As New ADODB.Recordset

'Declare Class variables
Private m_blnProceed As Boolean

Public Sub UserSelections()
   'Declare local variables
   Dim strSQL As String
   Dim intCount As Integer

   'Open the database and check for errors
   If Not OpenDatabase Then
      m_Response.Write "<P><strong><font color=""#FF0000"">" & _
         "Error Opening Database</font></strong><P>"
      Exit Sub
   End If
   
   'Build the order by clause based on request.form("AuthorOption")
   Select Case CInt(m_Request.Form("AuthorOption"))
      Case 0
         strSQL = "dbo.up_select_authors_by_last_name"
      Case 1
         strSQL = "dbo.up_select_authors_by_first_name"
      Case 2
         strSQL = "dbo.up_select_authors_by_title"
      Case Else
         strSQL = "dbo.up_select_authors_by_last_name"
   End Select

   On Error GoTo SQLErr
   'Set the cursorlocation
   m_objRs.CursorLocation = adUseClient
   'Open the recordset
   m_objRs.Open strSQL, m_objConn, adOpenForwardOnly, , adCmdText
   'Set the recordset to no active connection
   Set m_objRs.ActiveConnection = Nothing
   On Error GoTo 0
   
   'Close the database to free the connection
   Call CloseDatabase
   
   'Loop through the recordset matching the record to the
   'user's selections
   Do While Not m_objRs.EOF
      intCount = intCount + 1
      'If the length of the field is > 0 the user entered someting
      'so process their selection
      If Len(m_Request.Form("txtOrder" & intCount)) > 0 Then
         'You could validate the users input to make sure they entered
         'the correct value as in:
         If UCase(m_Request.Form("txtOrder" & intCount)) = "S" Then
            'Do the valid processing here
         Else
            'Handle invalid options here
         End If
      End If
      m_objRs.MoveNext
   Loop
   
   'Close the recordset
   Call CloseRecordset
   
   'Display a message indicating all processing is complete
   m_Response.Write "<P><strong>Your selections have been processed." & _
      "</strong><P>"
   
   Exit Sub
   
SQLErr:
   m_Response.Write "<P><strong><font color=""#FF0000"">" & _
      "SQL Error Occurred Reading From The Database</font></strong><P>"
End Sub


Private Sub CloseDatabase()
   'Close database objects and dereference them
   m_objConn.Close
   Set m_objConn = Nothing
End Sub
Private Sub CloseRecordset()
   'Close recordset objects and dereference them
   m_objRs.Close
   Set m_objRs = Nothing
End Sub


Public Sub OnEndPage()
   'Dereference all ScriptingContext objects
   Set m_Application = Nothing
   Set m_Request = Nothing
   Set m_Response = Nothing
   Set m_Session = Nothing
End Sub

Private Function OpenDatabase() As Boolean
   'Connect to SQL Server and open the database
   On Error GoTo SQLErr
   With m_objConn
      .ConnectionTimeout = CInt(m_Session("ConnectionTimeout"))
      .CommandTimeout = CInt(m_Session("CommandTimeout"))
      .Open m_Application("ConnectString")
   End With
   On Error GoTo 0
   OpenDatabase = True
   Exit Function
SQLErr:
   OpenDatabase = False
End Function
Public Sub OnStartPage(m_ScriptingContext As ScriptingContext)
   'Set references to the Web's ScriptingContext objects
   Set m_Application = m_ScriptingContext.Application
   Set m_Request = m_ScriptingContext.Request
   Set m_Response = m_ScriptingContext.Response
   Set m_Session = m_ScriptingContext.Session
End Sub

