<?xml version="1.0"?>
<xsl:stylesheet 
  xmlns:xsl="http://www.w3.org/TR/WD-xsl"
  xmlns="http://www.w3.org/TR/REC-html40"
  result-ns="">

<xsl:template match="text()">
   <xsl:value-of/>
</xsl:template>

<xsl:template match="/">

<HTML>

<HEAD>
<META http-equiv="Content-Language" content="en-us" />
<META http-equiv="Content-Type" content="text/html; charset=windows-1252" />
<META name="AUTHOR" content="PGB" />

<xsl:for-each select="Languages/Title">
  <TITLE>
   <xsl:value-of />
  </TITLE>
</xsl:for-each>

</HEAD>

<BODY>

<xsl:for-each select="Languages/Heading1">
  <H1>
   <xsl:value-of />
  </H1>
</xsl:for-each>

<HR />

<xsl:for-each select="Languages/Intro">
  <P>
   <xsl:value-of select="@Text" />
  </P>
</xsl:for-each>

<TABLE border="1" width="500">

<xsl:for-each select="Languages/Language">

  <TR>
   <TD width="10%">
     <FONT size="2">
      <B>
        <xsl:for-each select="Abbreviation">
         <xsl:value-of />
        </xsl:for-each>
      </B>
   </FONT>
   </TD>
   <TD width="50%">
   <FONT size="2">
      <xsl:for-each select="FullName">
        <xsl:value-of />
      </xsl:for-each>
   </FONT>
   </TD>
   <TD width="40%">
   <FONT size="2">
      <xsl:for-each select="Description">
        <xsl:value-of />
      </xsl:for-each>
   </FONT>
   </TD>
  </TR>
</xsl:for-each>
</TABLE>

<xsl:for-each select="Languages/FootNote">
  <P>
   <FONT size="2">
     <xsl:value-of select="@Text" />
   </FONT>
  </P>
</xsl:for-each>

</BODY>

</HTML>

</xsl:template>

</xsl:stylesheet>
